<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates&#x2F;framework&#x2F;dyndl&#x2F;realize&#x2F;src&#x2F;allocator&#x2F;mod.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mod.rs - source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../../storage.js"></script><script src="../../../crates.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../../dyndl_realize/index.html'><div class='logo-container rust-logo'><img src='../../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
<span id="361">361</span>
<span id="362">362</span>
<span id="363">363</span>
<span id="364">364</span>
<span id="365">365</span>
<span id="366">366</span>
<span id="367">367</span>
<span id="368">368</span>
<span id="369">369</span>
<span id="370">370</span>
<span id="371">371</span>
<span id="372">372</span>
<span id="373">373</span>
<span id="374">374</span>
<span id="375">375</span>
<span id="376">376</span>
<span id="377">377</span>
<span id="378">378</span>
<span id="379">379</span>
<span id="380">380</span>
<span id="381">381</span>
<span id="382">382</span>
<span id="383">383</span>
<span id="384">384</span>
<span id="385">385</span>
<span id="386">386</span>
<span id="387">387</span>
<span id="388">388</span>
<span id="389">389</span>
<span id="390">390</span>
<span id="391">391</span>
<span id="392">392</span>
<span id="393">393</span>
<span id="394">394</span>
<span id="395">395</span>
<span id="396">396</span>
<span id="397">397</span>
<span id="398">398</span>
<span id="399">399</span>
<span id="400">400</span>
<span id="401">401</span>
<span id="402">402</span>
<span id="403">403</span>
<span id="404">404</span>
<span id="405">405</span>
<span id="406">406</span>
<span id="407">407</span>
<span id="408">408</span>
<span id="409">409</span>
<span id="410">410</span>
<span id="411">411</span>
<span id="412">412</span>
<span id="413">413</span>
<span id="414">414</span>
<span id="415">415</span>
<span id="416">416</span>
<span id="417">417</span>
<span id="418">418</span>
<span id="419">419</span>
<span id="420">420</span>
<span id="421">421</span>
<span id="422">422</span>
<span id="423">423</span>
<span id="424">424</span>
<span id="425">425</span>
<span id="426">426</span>
<span id="427">427</span>
<span id="428">428</span>
<span id="429">429</span>
<span id="430">430</span>
<span id="431">431</span>
<span id="432">432</span>
<span id="433">433</span>
<span id="434">434</span>
<span id="435">435</span>
<span id="436">436</span>
<span id="437">437</span>
<span id="438">438</span>
<span id="439">439</span>
<span id="440">440</span>
<span id="441">441</span>
<span id="442">442</span>
<span id="443">443</span>
<span id="444">444</span>
<span id="445">445</span>
<span id="446">446</span>
<span id="447">447</span>
<span id="448">448</span>
<span id="449">449</span>
<span id="450">450</span>
<span id="451">451</span>
<span id="452">452</span>
<span id="453">453</span>
<span id="454">454</span>
<span id="455">455</span>
<span id="456">456</span>
<span id="457">457</span>
<span id="458">458</span>
<span id="459">459</span>
<span id="460">460</span>
<span id="461">461</span>
<span id="462">462</span>
<span id="463">463</span>
<span id="464">464</span>
<span id="465">465</span>
<span id="466">466</span>
<span id="467">467</span>
<span id="468">468</span>
<span id="469">469</span>
<span id="470">470</span>
<span id="471">471</span>
</pre><pre class="rust"><code><span class="attribute">#![<span class="ident">allow</span>(<span class="ident">dead_code</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">unused_variables</span>)]</span>

<span class="kw">use</span> <span class="ident">core::convert::TryFrom</span>;

<span class="kw">use</span> <span class="ident">icecap_core::prelude</span>::<span class="kw-2">*</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">CRegion</span>, <span class="ident">ElaboratedUntyped</span>, <span class="ident">Slot</span>, <span class="ident">UntypedId</span>};

<span class="kw">mod</span> <span class="ident">node</span>;

<span class="kw">use</span> <span class="ident">node</span>::{<span class="ident">AccessibleNodeType</span>, <span class="ident">LeafNodes</span>, <span class="ident">Node</span>, <span class="ident">NodeType</span>};

<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">AllocatorBuilder</span> {
    <span class="ident">cregion</span>: <span class="ident">CRegion</span>,
    <span class="ident">fragmentation_threshold_size_bits</span>: <span class="ident">usize</span>,
    <span class="ident">untyped</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">ElaboratedUntyped</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">AllocatorBuilder</span> {
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">cregion</span>: <span class="ident">CRegion</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="self">Self</span> {
            <span class="ident">cregion</span>,
            <span class="ident">fragmentation_threshold_size_bits</span>: <span class="number">0</span>,
            <span class="ident">untyped</span>: <span class="macro">vec!</span>[],
        }
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">add_untyped</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">untyped</span>: <span class="ident">ElaboratedUntyped</span>) {
        <span class="comment">// TODO: Verify that the untyped are disjoint.</span>
        <span class="self">self</span>.<span class="ident">untyped</span>.<span class="ident">push</span>(<span class="ident">untyped</span>);
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">set_fragmentation_threshold_size_bits</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="ident">fragmentation_threshold_size_bits</span>: <span class="ident">usize</span>,
    ) {
        <span class="self">self</span>.<span class="ident">fragmentation_threshold_size_bits</span> <span class="op">=</span> <span class="ident">fragmentation_threshold_size_bits</span>;
    }

    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">build</span>(<span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Allocator</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">allocator</span> <span class="op">=</span> <span class="ident">Allocator</span> {
            <span class="ident">cregion</span>: <span class="self">self</span>.<span class="ident">cregion</span>,
            <span class="ident">fragmentation_threshold_size_bits</span>: <span class="self">self</span>.<span class="ident">fragmentation_threshold_size_bits</span>,
            <span class="ident">cap_derivation_tree</span>: <span class="ident">Node::new</span>(),
            <span class="ident">leaf_nodes</span>: <span class="ident">LeafNodes::new</span>(),
        };

        <span class="comment">// Add the built ins to the derivation tree and to the leaf nodes.</span>
        <span class="kw">for</span> <span class="ident">untyped</span> <span class="kw">in</span> <span class="self">self</span>.<span class="ident">untyped</span>.<span class="ident">iter</span>() {
            <span class="kw">let</span> <span class="ident">untyped_cptr</span> <span class="op">=</span> <span class="ident">untyped</span>.<span class="ident">cptr</span>;
            <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="ident">untyped</span>.<span class="ident">untyped_id</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">low_addr</span> <span class="op">=</span> <span class="number">0</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">high_addr</span> <span class="op">=</span> <span class="number">0xFFFF_FFFF_FFFF_FFFF</span>;
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">depth</span> <span class="op">=</span> <span class="number">64</span>;

            <span class="comment">// We assume the untyped region will never be the root of the</span>
            <span class="comment">// capability derivation tree (e.g., paddr == 0 and</span>
            <span class="comment">// size_bits == 64).</span>
            <span class="macro">assert!</span>(<span class="op">!</span>(<span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">=</span><span class="op">=</span> <span class="number">0</span> <span class="op">&amp;&amp;</span> <span class="ident">untyped_id</span>.<span class="ident">size_bits</span> <span class="op">=</span><span class="op">=</span> <span class="number">64</span>));

            <span class="comment">// Verify the paddr is in bounds</span>
            <span class="macro">assert!</span>(<span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">low_addr</span> <span class="op">&amp;&amp;</span> <span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">high_addr</span>);

            <span class="comment">// Work down the tree, creating Inaccessible Nodes until we get</span>
            <span class="comment">// to the Node corresponding to the UntypedId, then create a</span>
            <span class="comment">// BuiltIn Node.</span>
            <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">allocator</span>.<span class="ident">cap_derivation_tree</span>;
            <span class="kw">while</span> <span class="ident">depth</span> <span class="op">&gt;</span> <span class="ident">untyped_id</span>.<span class="ident">size_bits</span> {
                <span class="kw">let</span> <span class="ident">half_addr</span> <span class="op">=</span> <span class="ident">low_addr</span> <span class="op">+</span> ((<span class="ident">high_addr</span> <span class="op">-</span> <span class="ident">low_addr</span>) <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>) <span class="op">+</span> <span class="number">1</span>;
                <span class="kw">if</span> <span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&lt;</span> <span class="ident">half_addr</span> {
                    <span class="ident">high_addr</span> <span class="op">=</span> <span class="ident">half_addr</span> <span class="op">-</span> <span class="number">1</span>;
                    <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">is_none</span>() {
                        <span class="ident">node</span>.<span class="ident">left</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">Box::new</span>(<span class="ident">Node</span> {
                            <span class="ident">node_type</span>: <span class="ident">NodeType::Inaccessible</span>,
                            <span class="ident">left</span>: <span class="prelude-val">None</span>,
                            <span class="ident">right</span>: <span class="prelude-val">None</span>,
                        }));
                    }
                    <span class="ident">node</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>();
                } <span class="kw">else</span> {
                    <span class="ident">low_addr</span> <span class="op">=</span> <span class="ident">half_addr</span>;
                    <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">is_none</span>() {
                        <span class="ident">node</span>.<span class="ident">right</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">Box::new</span>(<span class="ident">Node</span> {
                            <span class="ident">node_type</span>: <span class="ident">NodeType::Inaccessible</span>,
                            <span class="ident">left</span>: <span class="prelude-val">None</span>,
                            <span class="ident">right</span>: <span class="prelude-val">None</span>,
                        }));
                    }
                    <span class="ident">node</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>();
                }
                <span class="ident">depth</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
            }

            <span class="comment">// At this point, we should be at the depth of the BuiltIn</span>
            <span class="macro">assert_eq!</span>(<span class="ident">depth</span>, <span class="ident">untyped_id</span>.<span class="ident">size_bits</span>);

            <span class="comment">// The Node was created as Inaccessible, so we&#39;ll recreate it as</span>
            <span class="comment">// a BuiltIn and assign the untyped_cptr.</span>
            <span class="kw-2">*</span><span class="ident">node</span> <span class="op">=</span> <span class="ident">Node</span> {
                <span class="ident">node_type</span>: <span class="ident">NodeType::Accessible</span> {
                    <span class="ident">consumed</span>: <span class="bool-val">false</span>,
                    <span class="ident">accessible_node_type</span>: <span class="ident">AccessibleNodeType::BuiltIn</span> {
                        <span class="ident">local_cptr</span>: <span class="ident">untyped_cptr</span>,
                    },
                },
                <span class="ident">left</span>: <span class="prelude-val">None</span>,
                <span class="ident">right</span>: <span class="prelude-val">None</span>,
            };

            <span class="comment">// Add the BuiltIn to leaf_nodes</span>
            <span class="ident">allocator</span>.<span class="ident">leaf_nodes</span>.<span class="ident">add_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);
        }

        <span class="ident">allocator</span>
    }
}

<span class="doccomment">/// Structure used to allocate memory for Realms and Realm objects.</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Allocator</span> {
    <span class="ident">cregion</span>: <span class="ident">CRegion</span>,
    <span class="ident">fragmentation_threshold_size_bits</span>: <span class="ident">usize</span>,
    <span class="ident">cap_derivation_tree</span>: <span class="ident">Node</span>,
    <span class="ident">leaf_nodes</span>: <span class="ident">LeafNodes</span>,
}

<span class="kw">impl</span> <span class="ident">Allocator</span> {
    <span class="doccomment">/// Determine if there is sufficient Untyped left to create the number and</span>
    <span class="doccomment">/// size of objects provided to the function.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// count_by_size_bits: Vector indexed by size_bits containing a count of</span>
    <span class="doccomment">/// object requiring that many size bits.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// TODO: Function currently only ensures there is enough TOTAL space to</span>
    <span class="doccomment">/// fit all the objects, but it&#39;s possible that the BuiltIn Untyped regions</span>
    <span class="doccomment">/// are sized such that they cannot actually fit the provided objects (e.g.,</span>
    <span class="doccomment">/// we have two Untyped regions for 8 bytes and want an object requiring 16</span>
    <span class="doccomment">/// bytes).  We basically need to implement a knapsack solution to do this</span>
    <span class="doccomment">/// more robustly.  At the moment we assume that the BuiltIns provided will</span>
    <span class="doccomment">/// be sufficient for each of the objects requested.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">peek_space</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">count_by_size_bits</span>: <span class="kw-2">&amp;</span>[<span class="ident">usize</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">bool</span> {
        <span class="comment">// Get the total size requested.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">required_space</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">for</span> (<span class="ident">size_bits</span>, <span class="ident">count</span>) <span class="kw">in</span> <span class="ident">count_by_size_bits</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
            <span class="ident">required_space</span> <span class="op">+</span><span class="op">=</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">size_bits</span>) <span class="op">*</span> <span class="ident">count</span>;
        }

        <span class="comment">// Obtain the consumable space available in leaf nodes.</span>
        <span class="kw">let</span> <span class="ident">consumable_space</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">consumable_space</span>();

        <span class="comment">// Return true if there is sufficient consumable space.</span>
        <span class="ident">consumable_space</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">required_space</span>
    }

    <span class="doccomment">/// Create a new CNode with 2^radix slots.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">create_cnode</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">radix</span>: <span class="ident">usize</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>(<span class="ident">CRegion</span>, <span class="ident">UntypedId</span>, <span class="ident">Slot</span>)<span class="op">&gt;</span> {
        <span class="comment">// Get a slot in the allocator&#39;s CNode to place a cap to the new CNode.</span>

        <span class="comment">// Create a CRegion for the new CNode.</span>
        <span class="kw">let</span> <span class="ident">realm_slot</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">alloc</span>().<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">realm_cnode</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">relative_cptr</span>(<span class="ident">realm_slot</span>);
        <span class="kw">let</span> <span class="ident">guard</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">let</span> <span class="ident">guard_size</span> <span class="op">=</span> <span class="ident">u64::try_from</span>(<span class="number">64</span> <span class="op">-</span> <span class="ident">realm_cnode</span>.<span class="ident">path</span>.<span class="ident">depth</span> <span class="op">-</span> <span class="ident">radix</span>).<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">realm_cregion</span> <span class="op">=</span> <span class="ident">CRegion::new</span>(<span class="ident">realm_cnode</span>, <span class="ident">guard</span>, <span class="ident">guard_size</span>, <span class="ident">radix</span>);

        <span class="comment">// Create a blueprint for the CNode which will be used to create the object.</span>
        <span class="kw">let</span> <span class="ident">blueprint</span> <span class="op">=</span> <span class="ident">ObjectBlueprint::CNode</span> { <span class="ident">size_bits</span>: <span class="ident">radix</span> };

        <span class="comment">// The CPtr to the realm&#39;s CNode will be placed in the allocator&#39;s CNode.</span>
        <span class="kw">let</span> <span class="ident">destination_cnode</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">root</span>.<span class="ident">clone</span>();

        <span class="comment">// Create a temporary Slot and RelativeCPtr for the initial object.</span>
        <span class="kw">let</span> <span class="ident">temp_slot</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">alloc</span>().<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">temp_rel_cptr</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">relative_cptr</span>(<span class="ident">temp_slot</span>);
        <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">create_object</span>(<span class="kw-2">&amp;</span><span class="ident">destination_cnode</span>, <span class="ident">temp_slot</span>, <span class="ident">blueprint</span>);

        <span class="comment">// Mutate the temporary RelativeCPtr to add the realm CNode&#39;s guard and store it as</span>
        <span class="comment">// the CPtr to the realm&#39;s CNode.</span>
        <span class="ident">realm_cregion</span>
            .<span class="ident">root</span>
            .<span class="ident">mutate</span>(<span class="kw-2">&amp;</span><span class="ident">temp_rel_cptr</span>, <span class="ident">CNodeCapData::new</span>(<span class="ident">guard</span>, <span class="ident">guard_size</span>).<span class="ident">raw</span>())<span class="question-mark">?</span>;

        <span class="comment">// Clean up the temporary Slot and RelativeCPtr.</span>
        <span class="ident">temp_rel_cptr</span>.<span class="ident">delete</span>()<span class="question-mark">?</span>;
        <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">free</span>(<span class="ident">temp_slot</span>);

        <span class="prelude-val">Ok</span>((<span class="ident">realm_cregion</span>, <span class="ident">untyped_id</span>, <span class="ident">realm_slot</span>))
    }

    <span class="comment">// destination_cnode: cptr to the destination cnode</span>
    <span class="comment">// slot: slot in which to create the object</span>
    <span class="comment">// blueprint: blueprint of the object to be created</span>
    <span class="kw">fn</span> <span class="ident">create_object</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="ident">destination_cnode</span>: <span class="kw-2">&amp;</span><span class="ident">RelativeCPtr</span>,
        <span class="ident">slot</span>: <span class="ident">Slot</span>,
        <span class="ident">blueprint</span>: <span class="ident">ObjectBlueprint</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">UntypedId</span> {
        <span class="kw">let</span> <span class="ident">phys_size_bits</span> <span class="op">=</span> <span class="ident">blueprint</span>.<span class="ident">physical_size_bits</span>();

        <span class="comment">// Find a Node of Untyped to retype.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">get_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">phys_size_bits</span>);

        <span class="comment">// If the returned Untyped is too big, we need to split it.</span>
        <span class="kw">if</span> <span class="ident">untyped_id</span>.<span class="ident">size_bits</span> <span class="op">&gt;</span> <span class="ident">phys_size_bits</span> {
            <span class="comment">// The difference between phys_size_bits and next_smallest_size</span>
            <span class="comment">// identifies how many times we&#39;ll have to split the Untyped.</span>
            <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="ident">phys_size_bits</span>..<span class="ident">untyped_id</span>.<span class="ident">size_bits</span> {
                <span class="comment">// Split the Untyped into slots in the root CNode.</span>
                <span class="kw">let</span> (<span class="ident">left_child_untyped_id</span>, <span class="ident">right_child_untyped_id</span>) <span class="op">=</span>
                    <span class="self">self</span>.<span class="ident">split_untyped</span>(<span class="ident">untyped_id</span>);

                <span class="comment">// Work down the right side of the tree.</span>
                <span class="ident">untyped_id</span> <span class="op">=</span> <span class="ident">right_child_untyped_id</span>;
                <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">remove_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);
            }

            <span class="comment">// At this point, untyped_id is an Untyped of the correct size.</span>
        }

        <span class="comment">// Find the Node corresponding to the untyped_id</span>
        <span class="kw">let</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::get_node_mut</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">cap_derivation_tree</span>, <span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);

        <span class="comment">// Set the node to consumed, since we&#39;re about to retype it.</span>
        <span class="ident">node</span>.<span class="ident">set_consumed</span>(<span class="bool-val">true</span>);

        <span class="comment">// Get the local cptr for the Untyped and retype it into the destination cnode.</span>
        <span class="kw">let</span> <span class="ident">local_cptr</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">local_cptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>);
        <span class="ident">local_cptr</span>
            .<span class="ident">retype</span>(
                <span class="ident">blueprint</span>,
                <span class="kw-2">&amp;</span><span class="ident">destination_cnode</span>,
                <span class="ident">u64::try_from</span>(<span class="ident">slot</span>).<span class="ident">unwrap</span>(),
                <span class="number">1</span>,
            )
            .<span class="ident">unwrap</span>();

        <span class="comment">// Return the untyped id of the node that was retyped.</span>
        <span class="kw">return</span> <span class="ident">untyped_id</span>;
    }

    <span class="comment">// Splits an Untyped object and places the two new CPtrs into the CRegion&#39;s root CNode.</span>
    <span class="kw">fn</span> <span class="ident">split_untyped</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">untyped_id</span>: <span class="ident">UntypedId</span>) <span class="op">-</span><span class="op">&gt;</span> (<span class="ident">UntypedId</span>, <span class="ident">UntypedId</span>) {
        <span class="comment">// Create the blueprint for the new Untyped.</span>
        <span class="kw">let</span> <span class="ident">new_size_bits</span> <span class="op">=</span> <span class="ident">untyped_id</span>.<span class="ident">size_bits</span> <span class="op">-</span> <span class="number">1</span>;
        <span class="kw">let</span> <span class="ident">blueprint</span> <span class="op">=</span> <span class="ident">ObjectBlueprint::Untyped</span> {
            <span class="ident">size_bits</span>: <span class="ident">new_size_bits</span>,
        };

        <span class="comment">// Identify the slot numbers into which the Untyped will be split.</span>
        <span class="kw">let</span> <span class="ident">left_slot</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">alloc</span>().<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">right_slot</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">alloc</span>().<span class="ident">unwrap</span>();

        <span class="comment">// Find the node corresponding to the untyped_id to be split.</span>
        <span class="kw">let</span> <span class="ident">node</span> <span class="op">=</span> <span class="ident">Node::get_node_mut</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">cap_derivation_tree</span>, <span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);
        <span class="macro">assert!</span>(<span class="op">!</span><span class="ident">node</span>.<span class="ident">is_consumed</span>());

        <span class="comment">// Derive a local cptr to the Untyped.</span>
        <span class="kw">let</span> <span class="ident">local_cptr</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">local_cptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>);

        <span class="comment">// Split the Untyped by retyping into two Untyped regions.</span>
        <span class="ident">local_cptr</span>
            .<span class="ident">retype</span>(
                <span class="ident">blueprint</span>,
                <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">root</span>,
                <span class="ident">u64::try_from</span>(<span class="ident">left_slot</span>).<span class="ident">unwrap</span>(),
                <span class="number">1</span>,
            )
            .<span class="ident">unwrap</span>();
        <span class="ident">local_cptr</span>
            .<span class="ident">retype</span>(
                <span class="ident">blueprint</span>,
                <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">root</span>,
                <span class="ident">u64::try_from</span>(<span class="ident">right_slot</span>).<span class="ident">unwrap</span>(),
                <span class="number">1</span>,
            )
            .<span class="ident">unwrap</span>();

        <span class="comment">// Add the child Nodes to the parent Node.</span>
        <span class="ident">node</span>.<span class="ident">left</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">Box::new</span>(<span class="ident">Node</span> {
            <span class="ident">node_type</span>: <span class="ident">NodeType::Accessible</span> {
                <span class="ident">consumed</span>: <span class="bool-val">false</span>,
                <span class="ident">accessible_node_type</span>: <span class="ident">AccessibleNodeType::Managed</span> { <span class="ident">slot</span>: <span class="ident">left_slot</span> },
            },
            <span class="ident">left</span>: <span class="prelude-val">None</span>,
            <span class="ident">right</span>: <span class="prelude-val">None</span>,
        }));

        <span class="ident">node</span>.<span class="ident">right</span> <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">Box::new</span>(<span class="ident">Node</span> {
            <span class="ident">node_type</span>: <span class="ident">NodeType::Accessible</span> {
                <span class="ident">consumed</span>: <span class="bool-val">false</span>,
                <span class="ident">accessible_node_type</span>: <span class="ident">AccessibleNodeType::Managed</span> { <span class="ident">slot</span>: <span class="ident">right_slot</span> },
            },
            <span class="ident">left</span>: <span class="prelude-val">None</span>,
            <span class="ident">right</span>: <span class="prelude-val">None</span>,
        }));

        <span class="comment">// Add the new children to leaf_nodes.</span>
        <span class="kw">let</span> <span class="ident">left_child_untyped_id</span> <span class="op">=</span> <span class="ident">UntypedId</span> {
            <span class="ident">paddr</span>: <span class="ident">untyped_id</span>.<span class="ident">paddr</span>,
            <span class="ident">size_bits</span>: <span class="ident">new_size_bits</span>,
        };
        <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">add_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">left_child_untyped_id</span>);

        <span class="kw">let</span> <span class="ident">right_child_untyped_id</span> <span class="op">=</span> <span class="ident">UntypedId</span> {
            <span class="ident">paddr</span>: <span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">+</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="ident">new_size_bits</span>),
            <span class="ident">size_bits</span>: <span class="ident">new_size_bits</span>,
        };
        <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">add_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">right_child_untyped_id</span>);

        (<span class="ident">left_child_untyped_id</span>, <span class="ident">right_child_untyped_id</span>)
    }

    <span class="comment">// Creates multiple objects in the provided cregion based on the provided blueprints.</span>
    <span class="comment">// TODO: Refactor to create all the objects from a single Untyped to reduce syscalls.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">create_objects</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="ident">realm_cregion</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">CRegion</span>,
        <span class="ident">blueprints</span>: <span class="kw-2">&amp;</span>[<span class="ident">ObjectBlueprint</span>],
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>(<span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Slot</span><span class="op">&gt;</span>, <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">UntypedId</span><span class="op">&gt;</span>)<span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">slots</span> <span class="op">=</span> <span class="ident">Vec::new</span>();
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">untyped_ids</span> <span class="op">=</span> <span class="ident">Vec::new</span>();

        <span class="kw">for</span> (<span class="ident">idx</span>, <span class="ident">blueprint</span>) <span class="kw">in</span> <span class="ident">blueprints</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
            <span class="kw">let</span> <span class="ident">slot</span> <span class="op">=</span> <span class="ident">realm_cregion</span>.<span class="ident">alloc</span>().<span class="ident">unwrap</span>();
            <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">create_object</span>(<span class="kw-2">&amp;</span><span class="ident">realm_cregion</span>.<span class="ident">root</span>, <span class="ident">slot</span>, <span class="kw-2">*</span><span class="ident">blueprint</span>);
            <span class="ident">slots</span>.<span class="ident">push</span>(<span class="ident">slot</span>);
            <span class="ident">untyped_ids</span>.<span class="ident">push</span>(<span class="ident">untyped_id</span>);
        }

        <span class="prelude-val">Ok</span>((<span class="ident">slots</span>, <span class="ident">untyped_ids</span>))
    }

    <span class="doccomment">/// Recursively searches the capability derivation tree for the given</span>
    <span class="doccomment">/// UntypedId, revokes the Node&#39;s capability, frees the Untyped block</span>
    <span class="doccomment">/// to be reused, and then returns back up the tree, revoking and freeing</span>
    <span class="doccomment">/// parent Nodes that no longer have used child Nodes.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">revoke_and_free</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">untyped_id</span>: <span class="kw-2">&amp;</span><span class="ident">UntypedId</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// The root node is held by the capability derivation tree</span>

        <span class="comment">// TODO:  Cloning here and cloning back to avoid the &quot;you can&#39;t borrow *self mutably twice&quot;</span>
        <span class="comment">// error.  This strongly indicates a flaw in the structure or organisation and should be</span>
        <span class="comment">// fixed.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">node</span> <span class="op">=</span> <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">cap_derivation_tree</span>.<span class="ident">clone</span>();
        <span class="kw">let</span> <span class="ident">low_addr</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">let</span> <span class="ident">high_addr</span> <span class="op">=</span> <span class="number">0xFFFF_FFFF_FFFF_FFFF</span>;
        <span class="kw">let</span> <span class="ident">depth_from_root</span> <span class="op">=</span> <span class="number">0</span>;

        <span class="self">self</span>.<span class="ident">revoke_and_free_helper</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">node</span>, <span class="ident">low_addr</span>, <span class="ident">high_addr</span>, <span class="ident">depth_from_root</span>, <span class="ident">untyped_id</span>)<span class="question-mark">?</span>;

        <span class="self">self</span>.<span class="ident">cap_derivation_tree</span> <span class="op">=</span> <span class="ident">node</span>.<span class="ident">clone</span>();

        <span class="prelude-val">Ok</span>(())
    }

    <span class="comment">// Recursive helper function for revoke_and_free()</span>
    <span class="kw">fn</span> <span class="ident">revoke_and_free_helper</span>(
        <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>,
        <span class="ident">node</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">Node</span>,
        <span class="ident">low_addr</span>: <span class="ident">usize</span>,
        <span class="ident">high_addr</span>: <span class="ident">usize</span>,
        <span class="ident">depth_from_root</span>: <span class="ident">usize</span>,
        <span class="ident">untyped_id</span>: <span class="kw-2">&amp;</span><span class="ident">UntypedId</span>,
    ) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Fallible</span><span class="op">&lt;</span>()<span class="op">&gt;</span> {
        <span class="comment">// Check if we&#39;re at the correct level of the tree.</span>
        <span class="kw">if</span> (<span class="number">64</span> <span class="op">-</span> <span class="ident">depth_from_root</span>) <span class="op">=</span><span class="op">=</span> <span class="ident">untyped_id</span>.<span class="ident">size_bits</span> {
            <span class="comment">// Enforce the invariant that we only revoke and free accessible,</span>
            <span class="comment">// consumed, nodes without children.</span>
            <span class="macro">assert!</span>(<span class="ident">node</span>.<span class="ident">is_accessible</span>());
            <span class="macro">assert!</span>(<span class="ident">node</span>.<span class="ident">is_consumed</span>());
            <span class="macro">assert!</span>(<span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">is_none</span>() <span class="op">&amp;&amp;</span> <span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">is_none</span>());

            <span class="comment">// TODO: The invariant that the paddr is aligned to size bits should be</span>
            <span class="comment">// enforced on UntypedId.</span>
            <span class="macro">assert_eq!</span>(<span class="ident">low_addr</span>, <span class="ident">untyped_id</span>.<span class="ident">paddr</span>);

            <span class="comment">// Revoke the capability pointed to by the Node.</span>
            <span class="ident">node</span>.<span class="ident">relative_cptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>).<span class="ident">revoke</span>()<span class="question-mark">?</span>;

            <span class="comment">// Set consumed to false.</span>
            <span class="ident">node</span>.<span class="ident">set_consumed</span>(<span class="bool-val">false</span>);

            <span class="comment">// Add the freed Untyped to the leaf_nodes structure.</span>
            <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">add_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);

            <span class="comment">// We don&#39;t need to free the slot in the realm CNode because this</span>
            <span class="comment">// function only gets called when the realm is being destroyed, so</span>
            <span class="comment">// we aren&#39;t at risk of leaking slots.</span>

            <span class="comment">// If we&#39;re too high in the tree, recurse down.</span>
        } <span class="kw">else</span> {
            <span class="comment">// Verify the paddr is in bounds</span>
            <span class="macro">assert!</span>(<span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&gt;</span><span class="op">=</span> <span class="ident">low_addr</span> <span class="op">&amp;&amp;</span> <span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">high_addr</span>);

            <span class="kw">let</span> <span class="ident">half_addr</span> <span class="op">=</span> <span class="ident">low_addr</span> <span class="op">+</span> ((<span class="ident">high_addr</span> <span class="op">-</span> <span class="ident">low_addr</span>) <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>) <span class="op">+</span> <span class="number">1</span>;
            <span class="kw">if</span> <span class="ident">untyped_id</span>.<span class="ident">paddr</span> <span class="op">&lt;</span> <span class="ident">half_addr</span> {
                <span class="comment">// Recurse down the left child.</span>
                <span class="macro">assert!</span>(<span class="op">!</span><span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">is_none</span>());
                <span class="self">self</span>.<span class="ident">revoke_and_free_helper</span>(
                    <span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>(),
                    <span class="ident">low_addr</span>,
                    <span class="ident">half_addr</span> <span class="op">-</span> <span class="number">1</span>,
                    <span class="ident">depth_from_root</span> <span class="op">+</span> <span class="number">1</span>,
                    <span class="ident">untyped_id</span>,
                )<span class="question-mark">?</span>;
            } <span class="kw">else</span> {
                <span class="comment">// Recurse down the right child.</span>
                <span class="macro">assert!</span>(<span class="op">!</span><span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">is_none</span>());
                <span class="self">self</span>.<span class="ident">revoke_and_free_helper</span>(
                    <span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">as_mut</span>().<span class="ident">unwrap</span>(),
                    <span class="ident">half_addr</span>,
                    <span class="ident">high_addr</span>,
                    <span class="ident">depth_from_root</span> <span class="op">+</span> <span class="number">1</span>,
                    <span class="ident">untyped_id</span>,
                )<span class="question-mark">?</span>;
            }

            <span class="comment">// If the node is accessible and its children are deletable (or empty),</span>
            <span class="comment">// revoke the Node&#39;s capability, add it to LeafNodes, and delete the children.</span>
            <span class="kw">if</span> <span class="ident">node</span>.<span class="ident">is_accessible</span>()
                <span class="op">&amp;&amp;</span> (<span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">is_none</span>() <span class="op">|</span><span class="op">|</span> <span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>().<span class="ident">is_deletable</span>())
                <span class="op">&amp;&amp;</span> (<span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">is_none</span>() <span class="op">|</span><span class="op">|</span> <span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>().<span class="ident">is_deletable</span>())
            {
                <span class="comment">// Clean up the children.</span>
                <span class="kw">if</span> <span class="op">!</span><span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">is_none</span>() {
                    <span class="comment">// Free the child&#39;s slot in the Managed CNode.</span>
                    <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">free</span>(<span class="ident">node</span>.<span class="ident">left</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>().<span class="ident">get_slot</span>());

                    <span class="comment">// Derive the child&#39;s UntypedId and remove it from the leaf_nodes structure.</span>
                    <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="ident">UntypedId</span> {
                        <span class="ident">paddr</span>: <span class="ident">low_addr</span>,
                        <span class="ident">size_bits</span>: <span class="number">64</span> <span class="op">-</span> (<span class="ident">depth_from_root</span> <span class="op">+</span> <span class="number">1</span>),
                    };
                    <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">remove_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);

                    <span class="comment">// Delete child nodes.</span>
                    <span class="ident">node</span>.<span class="ident">left</span> <span class="op">=</span> <span class="prelude-val">None</span>;
                }

                <span class="kw">if</span> <span class="op">!</span><span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">is_none</span>() {
                    <span class="comment">// Free the child&#39;s slot in the Managed CNode.</span>
                    <span class="self">self</span>.<span class="ident">cregion</span>.<span class="ident">free</span>(<span class="ident">node</span>.<span class="ident">right</span>.<span class="ident">as_ref</span>().<span class="ident">unwrap</span>().<span class="ident">get_slot</span>());

                    <span class="comment">// Derive the child&#39;s UntypedId and remove it from the leaf_nodes structure.</span>
                    <span class="kw">let</span> <span class="ident">half_addr</span> <span class="op">=</span> <span class="ident">low_addr</span> <span class="op">+</span> ((<span class="ident">high_addr</span> <span class="op">-</span> <span class="ident">low_addr</span>) <span class="op">&gt;</span><span class="op">&gt;</span> <span class="number">1</span>) <span class="op">+</span> <span class="number">1</span>;
                    <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="ident">UntypedId</span> {
                        <span class="ident">paddr</span>: <span class="ident">half_addr</span>,
                        <span class="ident">size_bits</span>: <span class="number">64</span> <span class="op">-</span> (<span class="ident">depth_from_root</span> <span class="op">+</span> <span class="number">1</span>),
                    };
                    <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">remove_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);

                    <span class="comment">// Delete child nodes.</span>
                    <span class="ident">node</span>.<span class="ident">right</span> <span class="op">=</span> <span class="prelude-val">None</span>;
                }

                <span class="comment">// Invoke revoke() on this node&#39;s capability (to revoke it&#39;s children)</span>
                <span class="ident">node</span>.<span class="ident">relative_cptr</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">cregion</span>).<span class="ident">revoke</span>()<span class="question-mark">?</span>;

                <span class="comment">// Derive the node&#39;s UntypedId.</span>
                <span class="kw">let</span> <span class="ident">untyped_id</span> <span class="op">=</span> <span class="ident">UntypedId</span> {
                    <span class="ident">paddr</span>: <span class="ident">low_addr</span>,
                    <span class="ident">size_bits</span>: <span class="number">64</span> <span class="op">-</span> <span class="ident">depth_from_root</span>,
                };

                <span class="comment">// Add the node&#39;s freed Untyped to the leaf_nodes structure.</span>
                <span class="self">self</span>.<span class="ident">leaf_nodes</span>.<span class="ident">add_leaf</span>(<span class="kw-2">&amp;</span><span class="ident">untyped_id</span>);
            }
        }
        <span class="prelude-val">Ok</span>(())
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../../" data-current-crate="dyndl_realize" data-search-index-js="../../../search-index.js" data-search-js="../../../search.js"></div>
    <script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script>
</body></html>